# Before `make install' is performed this script should be runnable
# with `make test'. After `make install' it should work as `perl
# URLInputSource.t'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..5\n"; }
END {print "not ok 1\n" unless $loaded;}
use Carp;
use XML::Xerces;
use Cwd;

use lib 't';
use TestUtils qw(result $PERSONAL_FILE_NAME);
use vars qw($i $loaded $file);
use strict;

$loaded = 1;
$i = 1;
result($loaded);

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):


#
# This test monitors a heinous setErrorHandler() bug, in which
#   no internal reference to the perl handler object was maintained
#   and so when it went out of scope it was destroyed, and caused
#   core dumps
#

$file = '.domparsetest';
open(OUT,">$file")
  or die "Couldn't open $file for writing\n";

print OUT <<'EOT';
use Carp;
use blib;
use XML::Xerces;
use Cwd;

use lib 't';
use TestUtils qw($DOM);

package MyErrorHandler;
use strict;
use vars qw(@ISA);
@ISA = qw(XML::Xerces::PerlErrorHandler);

sub fatal_error {sub exit(0);}

package main;
{
  my $ERROR_HANDLER = MyErrorHandler->new();
  $DOM->setErrorHandler($ERROR_HANDLER);
}
# a bogus URL to cause a fatal error
my $URL = "file://../foo";
$DOM->parse(XML::Xerces::URLInputSource->new(XML::Xerces::XMLURL->new($URL)));
EOT

# if we get an exit value of zero we succeeded
system("perl $file 2>/dev/null");
result(! $?);

END {unlink $file;}

# test that our error handler generates a die() with a fatal error
my $DOM = XML::Xerces::DOMParser->new();
my $ERROR_HANDLER = XML::Xerces::PerlErrorHandler->new();
$DOM->setErrorHandler($ERROR_HANDLER);
eval "$DOM->parse(XML::Xerces::LocalFileInputSource->new('/I/AM/NOT/A/FILE'));";
result($@);

# now test DOMParser::reset
$DOM->reset();
result(1);

# now test the overloaded methods in DOMParser
$DOM->parse($PERSONAL_FILE_NAME);
result(1);
